***** OPN PLAY *****
***** Programmed by Sasaji
***** Version 0.2

	ORG $B000
*****	SETDP $B0

P_VECFIRQ	EQU $EEEE
P_OPNDATA	EQU $FF1E
P_OPNADDR	EQU $FF1F
P_TIMER		EQU $FFCA
P_TIME_MASK	EQU $FFD4
P_KEYBOARD	EQU $FFE0
CHANNEL_MAX	EQU $06
P_DATA_START	EQU $B800
P_VOICE_START	EQU $B810

	LBRA START

**** $03

FUNCNUM		FCB $00
ARG1		FCB $00
RETCODEH	FCB $00		: RETCODE H
RETCODEL	FCB $00		: RETCODE L

**** $07

SINGLE_PLAY	FCB $FF			: t`lw Bit

**** OPN SCALE - K $08

OPN_SCALE_C	FDB $0000
OPN_SCALE_CP	FDB $0000
OPN_SCALE_D	FDB $0000
OPN_SCALE_DP	FDB $0000
OPN_SCALE_E	FDB $0000
OPN_SCALE_FX	FDB $0000
OPN_SCALE_F	FDB $0000
OPN_SCALE_FP	FDB $0000
OPN_SCALE_G	FDB $0000
OPN_SCALE_GP	FDB $0000
OPN_SCALE_A	FDB $0000
OPN_SCALE_AP	FDB $0000
OPN_SCALE_B	FDB $0000
OPN_SCALE_CX	FDB $0000

**** SSG SCALE - SSG K $24

SSG_SCALE_C	FDB $0000
SSG_SCALE_CP	FDB $0000
SSG_SCALE_D	FDB $0000
SSG_SCALE_DP	FDB $0000
SSG_SCALE_E	FDB $0000
SSG_SCALE_FX	FDB $0000
SSG_SCALE_F	FDB $0000
SSG_SCALE_FP	FDB $0000
SSG_SCALE_G	FDB $0000
SSG_SCALE_GP	FDB $0000
SSG_SCALE_A	FDB $0000
SSG_SCALE_AP	FDB $0000
SSG_SCALE_B	FDB $0000
SSG_SCALE_CX	FDB $0000

***** Octave IN^[u $40

OCTAVE_0	FCB $04
OCTAVE_1	FCB $04
OCTAVE_2	FCB $04
OCTAVE_3	FCB $04
OCTAVE_4	FCB $04
OCTAVE_5	FCB $04

***** $46

SCORE_NUM_0	FCB $00
SCORE_NUM_1	FCB $00
SCORE_NUM_2	FCB $00
SCORE_NUM_3	FCB $00
SCORE_NUM_4	FCB $00
SCORE_NUM_5	FCB $00

***** $4C

LOOP		FCB $00
CHANNEL		FCB $00
CHANNEL_BIT	FCB $01
TEMPO		FCB $10
TIMER_COUNT	FCB $00
SSG_KEYON	FCB $FF
SSG_ENVELOP	FCB $00

RESERVED1	FCB $12

***** tf[^Jnʒu $54

DATA_START_0	FDB $C000
DATA_START_1	FDB $C400
DATA_START_2	FDB $C800
DATA_START_3	FDB $CC00
DATA_START_4	FDB $D000
DATA_START_5	FDB $D400

***** tf[^ʒu $60

DATA_CURRENT_0	FDB $C000
DATA_CURRENT_1	FDB $C400
DATA_CURRENT_2	FDB $C800
DATA_CURRENT_3	FDB $CC00
DATA_CURRENT_4	FDB $D000
DATA_CURRENT_5	FDB $D400

***** c^C $6C

REMAIN_TIME_0	FDB $FFFF
REMAIN_TIME_1	FDB $FFFF
REMAIN_TIME_2	FDB $FFFF
REMAIN_TIME_3	FDB $FFFF
REMAIN_TIME_4	FDB $FFFF
REMAIN_TIME_5	FDB $FFFF

***** $78

VECFIRQ_BACKUP	FCB $7E,$FD,$9B

***** $7B

OPN_VOLUME_0	FCB $00,$00,$00,$00
OPN_VOLUME_1	FCB $00,$00,$00,$00
OPN_VOLUME_2	FCB $00,$00,$00,$00

***** $87

SSG_VOLUME_0	FCB $08
SSG_VOLUME_1	FCB $08
SSG_VOLUME_2	FCB $08

***** $8A

OPN_VOICENUM_0	FCB $00
OPN_VOICENUM_1	FCB $00
OPN_VOICENUM_2	FCB $00

***** $8D

KEY_ARRAY	FCB $C7,$CD,$CE,$B7,$BD,$BE
KEY_PUSHED	FCB $00

***** $93

RESERVED2	FCB $12,$12,$12,$12

***** $98

START
	PSHS CC,A,B,DP,X,Y,U
	LDD 2,X
	STD FUNCNUM,PCR

	CLR RETCODEH,PCR
	CLR RETCODEL,PCR
	BRA LOOP_START	: C[v
END
	**** RETURN CODE (INTEGER)
	LDX 4,S
	LDD RETCODEH,PCR
	STD 2,X
	PULS CC,A,B,DP,X,Y,U
	RTS

**** [v

LOOP_START
	LBSR BACKUP_FIRQ_VECTOR
	LBSR INIT_PARAMS
	LBSR SET_FIRQ_VECTOR

	BSR WAIT_TIMER

	LBSR TERM_PARAMS
	LBSR RESTORE_FIRQ_VECTOR
	ANDCC $AF

	BRA END

**** ^C}荞ݑ҂

WAIT_TIMER
	CLRA
	LDB #CHANNEL_MAX
WAIT_TIMER_0
	LSLA
	ORA #$01
	DECB
	BNE WAIT_TIMER_0
	STA LOOP,PCR

	LDA #$01
	STA TIMER_COUNT,PCR

	LDA #$81	: 1ms^C}荞݊Jn
	STA P_TIME_MASK	: Start timer
	ANDCC $AF
WAIT_TIMER_1
	LDA P_KEYBOARD
	CMPA #$8C	: ESCL[H
	BEQ WAIT_TIMER_END1

	CMPA #$FF	: L[𗣂H
	BNE WAIT_TIMER_SKIP_0
	CLR KEY_PUSHED,PCR
WAIT_TIMER_SKIP_0
	CMPA #$A7	: NUM 0 L[H
	BNE WAIT_TIMER_SKIP_1
	LDB #$FF
	STB SINGLE_PLAY,PCR
WAIT_TIMER_SKIP_1
	CLRB
	LEAX KEY_ARRAY,PCR
WAIT_TIMER_KEY_L1
	CMPA ,X+	: NUM 1 - 6 L[H
	BNE WAIT_TIMER_SKIP_2
	TST KEY_PUSHED,PCR
	BNE WAIT_TIMER_SKIP_2
	PSHS B,A
	LDA #$01
	LBSR LSHIFT
	EORA SINGLE_PLAY,PCR	: w`lON/OFF
	STA SINGLE_PLAY,PCR
	LDA #$01
	STA KEY_PUSHED,PCR
	PULS A,B
WAIT_TIMER_SKIP_2
	INCB
	CMPB #CHANNEL_MAX
	BNE WAIT_TIMER_KEY_L1

	TST LOOP,PCR
	BNE WAIT_TIMER_1 : LOOPIłȂ

WAIT_TIMER_END1
	LDA #$82
	STA P_TIME_MASK	: Stop timer
	RTS

**** ^C}[荞

FIRQ_SUBROUTINE
	PSHS U,Y,X,DP,B,A
	LDA P_TIMER
	BSR PLAY_LOOP_MAIN
	PULS A,B,DP,X,Y,U
	RTI

**** C

PLAY_LOOP_MAIN
	DEC TIMER_COUNT,PCR
	BEQ J_PLM_START
	RTS

J_PLM_START
	LEAU CHANNEL,PCR
	LDA #$01
	STA 1,U		: CHANNEL_BIT
	LDA #$00
	STA ,U		: CHANNEL
	LSLA		: x2
	LEAY REMAIN_TIME_0,PCR
	LEAY A,Y
	LEAX DATA_CURRENT_0,PCR
	LEAX A,X
J_PLM_1
	PSHS X	: {1
	LDX ,X	: f[^ʒu
	BEQ J_PLM_CMD_IS_00		: f[^Ȃ

J_PLM_2
	LDD ,Y	: c^C}[
	CMPD #$0000
	BLE J_PLM_ZEROMINUS
J_PLM_PLUS
	SUBD #$0001
	STD ,Y	: c^C}[Zbg
	LBRA J_PLM_END

J_PLM_ZEROMINUS
	LDA ,X+	: f[^Ǎ
	TSTA
	BNE J_PLM_CMD_IS_00_E

J_PLM_CMD_IS_00
	**** f[^I
	LDA 1,U
	COMA
	ANDA LOOP,PCR
	STA LOOP,PCR
	BRA J_PLM_END
J_PLM_CMD_IS_00_E

	**** H
	CMPA #$02
	BLO J_PLM_CMD_IS_SCORE_E
	CMPA #$10
	BHS J_PLM_CMD_IS_SCORE_E
	LBSR STORE_SCORE_DATA		: XRAf[^
	BRA J_PLM_TIME_ZERO
J_PLM_CMD_IS_SCORE_E

	**** xH
	CMPA #$10
	BNE J_PLM_CMD_IS_REST_E
J_PLM_CMD_IS_REST
	LBSR STORE_REST_DATA
	BRA J_PLM_TIME_ZERO
J_PLM_CMD_IS_REST_E

	**** H
	CMPA #$11
	BNE J_PLM_CMD_IS_ADDLEN_E
J_PLM_CMD_IS_ADDLEN
	LBSR ADD_LENGTH
	BRA J_PLM_TIME_ZERO
J_PLM_CMD_IS_ADDLEN_E

	**** ʐݒ"V"(OPN)H
	CMPA #$12
	BNE J_PLM_CMD_IS_SETVOLOPN_E
J_PLM_CMD_IS_SET_VOLOPN
	LBSR SET_VOLOPN
	BRA J_PLM_ZEROMINUS
J_PLM_CMD_IS_SETVOLOPN_E

	**** ʐݒ"V"(SSG)H
	CMPA #$13
	BNE J_PLM_CMD_IS_SETVOLSSG_E
J_PLM_CMD_IS_SET_VOLSSG
	LBSR SET_VOLSSG
	BRA J_PLM_ZEROMINUS
J_PLM_CMD_IS_SETVOLSSG_E

	**** IN^[uݒ"O"H
	CMPA #$14
	BNE J_PLM_CMD_IS_SETOCTAVE_E
J_PLM_CMD_IS_SETOCTAVE
	LBSR SET_OCTAVE
	BRA J_PLM_ZEROMINUS
J_PLM_CMD_IS_SETOCTAVE_E

	**** e|ݒ"T"H
	CMPA #$15
	BNE J_PLM_CMD_IS_SETTEMPO_E
J_PLM_CMD_IS_SET_TEMPO
	LBSR SET_TEMPO
	BRA J_PLM_ZEROMINUS
J_PLM_CMD_IS_SETTEMPO_E

	**** Fݒ"@"H
	CMPA #$16
	BNE J_PLM_CMD_IS_SETVOICE_E
J_PLM_CMD_IS_SETVOICE
	LBSR SET_VOICE
	BRA J_PLM_ZEROMINUS
J_PLM_CMD_IS_SETVOICE_E

	**** SSGGx[v"S"H
	CMPA #$17
	BNE J_PLM_CMD_IS_SSGENVTYPE_E
J_PLM_CMD_IS_SSGENVTYPE
	LBSR SSG_ENVTYPE
	BRA J_PLM_ZEROMINUS
J_PLM_CMD_IS_SSGENVTYPE_E

	**** SSGGx[v"M"H
	CMPA #$18
	BNE J_PLM_CMD_IS_SSGENVLEN_E
J_PLM_CMD_IS_SSGENVLEN
	LBSR SSG_ENVLENGTH
	BRA J_PLM_ZEROMINUS
J_PLM_CMD_IS_SSGENVLEN_E

	**** WX^ݒ"Y"H
	CMPA #$19
	BNE J_PLM_CMD_IS_SETREG_E
J_PLM_CMD_IS_SETREG
	LBSR SET_REGISTER
	BRA J_PLM_ZEROMINUS
J_PLM_CMD_IS_SETREG_E

	**** JUMPH
	CMPA #$1F
	BNE J_PLM_CMD_IS_JUMP_E
J_PLM_CMD_IS_JUMP
	LBSR PLM_CMD_JUMP
	LBRA J_PLM_ZEROMINUS
J_PLM_CMD_IS_JUMP_E

J_PLM_TIME_ZERO
	LDD ,Y	: c^C}[
	CMPD #$0000
	LBLT J_PLM_ZEROMINUS

J_PLM_END
	TFR X,D
	PULS X	: 1}
	STD ,X++
	LEAY 2,Y
	LSL 1,U		: CHANNEL_BIT
	INC ,U		: CHANNEL
	LDB ,U
	CMPB #CHANNEL_MAX
	LBNE J_PLM_1

	LDA TEMPO,PCR
	STA TIMER_COUNT,PCR

	RTS

**** SCORE A - G

STORE_SCORE_DATA
	PSHS X			: {1
	LEAX SCORE_NUM_0,PCR
	LDB ,U	: CHANNEL
	SUBA #$02
	STA B,X
	PULS X			: 1}

	LDB ,X+	: Ǎ
	CLRA
	STD ,Y : c^C}[

	LDB ,U	: CHANNEL
	CMPB #$03
	BHS STORE_SCORE_DATA_SSG

STORE_SCORE_DATA_OPN
	PSHS X			: {2

	BSR OPN_KEY_OFF

	LEAX SCORE_NUM_0,PCR
	LDB B,X
	LSLB			: x2
	LEAX OPN_SCALE_C,PCR
	LDD B,X
	PSHS B,A		 : {3 f[^ޔ
	LEAX OCTAVE_0,PCR
	LDB ,U	: CHANNEL
	LDA B,X	: IN^[u(BLOCK)bit3-bit6
	LSLA
	LSLA
	LSLA
	LDB ,S	: F-Numberbit8-bit10
	ANDB #$07
	PSHS A			: {4
	ORB ,S
	LEAS 1,S		: 4}
	LDA #$A4
	ORA ,U	: CHANNEL
	LBSR WRITE_OPN

	PULS A,B		: 3}
	LDA #$A0
	ORA ,U	: CHANNEL
	LBSR WRITE_OPN

	LDA SINGLE_PLAY,PCR
	BITA 1,U
	BEQ STORE_SCORE_DATA_OPN_SKIP_KEYON

	BSR OPN_KEY_ON

STORE_SCORE_DATA_OPN_SKIP_KEYON

	PULS X			: 2}
	RTS

OPN_KEY_ON
	LDB #$F0
	FCB $81			: dummy
OPN_KEY_OFF
	CLRB
	ORB ,U	: CHANNEL
	LDA #$28
	LBSR WRITE_OPN		 : OPN KEY-ON-OFF
	RTS

STORE_SCORE_DATA_SSG
	PSHS X			: {4
	LEAX SCORE_NUM_0,PCR
	LDB B,X
	LSLB			: x2
	LEAX SSG_SCALE_C,PCR
	LDD B,X

	PSHS B,A		: {5

	LEAX OCTAVE_0,PCR
	LDB ,U	: CHANNEL
	LDB B,X
	LDX #$FFFD	: -3
	ABX

	PULS A,B		: 5}

	CMPX #$0000
	BEQ STORE_SCORE_DATA_SSG_OK
	BGE STORE_SCORE_DATA_SSG_PLUS
STORE_SCORE_DATA_SSG_MINUS
	LSLB	: 2{
	ROLA	: 2{
	LEAX 1,X
	BNE STORE_SCORE_DATA_SSG_MINUS
	BRA STORE_SCORE_DATA_SSG_OK
STORE_SCORE_DATA_SSG_PLUS
	LSRA	: 1/2{
	RORB	: 1/2{
	LEAX -1,X
	BNE STORE_SCORE_DATA_SSG_PLUS
STORE_SCORE_DATA_SSG_OK
	PSHS B,A		: {6
	TFR A,B
	LDA #$01
	ADDA ,U	: CHANNEL
	ADDA ,U	: CHANNEL
	SUBA #$06
	LBSR WRITE_OPN
	PULS A,B		: 6}
	CLRA
	ADDA ,U	: CHANNEL
	ADDA ,U	: CHANNEL
	SUBA #$06
	LBSR WRITE_OPN

	LDA ,U		: CHANNEL
	SUBA #$03
	LEAX SSG_VOLUME_0,PCR	: SSG {[
	LDB A,X
	ADDA #$08
	LBSR WRITE_OPN

	BITB #$10
	BEQ STORE_SCORE_DATA_SSG_SKIP_ENV

	LDA #$0D
	LDB SSG_ENVELOP,PCR	: SSG Gx[v
	LBSR WRITE_OPN

STORE_SCORE_DATA_SSG_SKIP_ENV

	LDA SINGLE_PLAY,PCR
	BITA 1,U
	BNE STORE_SCORE_DATA_SSG_KEYON
	BSR SSG_KEY_OFF
	BRA STORE_SCORE_DATA_SSG_END
STORE_SCORE_DATA_SSG_KEYON
	BSR SSG_KEY_ON

STORE_SCORE_DATA_SSG_END
	PULS X			: 4}
	RTS

****
SSG_KEY_ON
	LDA #$07
	LDB SSG_KEYON,PCR	: SSG KEY-ON
	LBSR WRITE_OPN
	RTS

SSG_KEY_OFF
	LDA #$08
	ADDA ,U		: CHANNEL
	SUBA #$03
	LDB #$00	: SSG {[
	LBSR WRITE_OPN

	LDA #$09
	LDB ,U		: CHANNEL
	SUBB #$03
	LBSR LSHIFT
	TFR A,B
	LDA #$07
	ORB SSG_KEYON,PCR	: SSG KEY-OFF
	LBSR WRITE_OPN
	RTS

**** SCORE R

STORE_REST_DATA
	LDB ,X+	: Ǎ
	CLRA
	STD ,Y : c^C}[

	LDB ,U	: CHANNEL
	CMPB #$03
	BHS STORE_REST_DATA_SSG
STORE_REST_DATA_OPN

	LBSR OPN_KEY_OFF
	RTS

STORE_REST_DATA_SSG

	BSR SSG_KEY_OFF

	RTS

**** ǉ no keyon/off

ADD_LENGTH
	LDB ,X+	: Ǎ
	CLRA
	STD ,Y : c^C}[

	LDA SINGLE_PLAY,PCR
	BITA 1,U
	BNE ADD_LENGTH_END

	LDB ,U
	CMPB #$03
	BHS ADD_LENGTH_SSG
ADD_LENGTH_OPN
	LBSR OPN_KEY_OFF
	BRA ADD_LENGTH_END

ADD_LENGTH_SSG
	BSR SSG_KEY_OFF

ADD_LENGTH_END
	RTS

**** IN^[uݒ"O"

SET_OCTAVE
	LDA ,X+
	DECA
	PSHS X
	LEAX OCTAVE_0,PCR
	LDB ,U
	STA B,X
	PULS X
	RTS

**** ʐݒ"V" (OPN)

SET_VOLOPN
	PSHS Y
	LEAY OPN_VOLUME_0,PCR
	LDB ,U
	LSLB
	LSLB		: x4
	LEAY B,Y
	LDB #$04
	LBSR MEMCPY

	LEAY -4,Y
	LDA #$40
	ADDA ,U
SET_VOLOPN_LOOP
	LDB ,Y+
	LBSR WRITE_OPN
	ADDA #$04
	CMPA #$50
	BLO SET_VOLOPN_LOOP

	PULS Y
	RTS

**** ʐݒ"V" (SSG)

SET_VOLSSG
	LDA ,X+
	PSHS X
	LEAX SSG_VOLUME_0,PCR
	LDB ,U
	SUBB #$03
	STA B,X
	PULS X
	RTS

**** e|ݒ"T"

SET_TEMPO
	LDA ,X+
	STA TEMPO,PCR
	RTS

**** SSGGx[v"S"

SSG_ENVTYPE
	LDA ,X+
	LDB ,U
	CMPB #$03
	BLO SSG_ENVTYPE_END

	STA SSG_ENVELOP,PCR
	SUBB #$03
	LDA #$1F
	PSHS X
	LEAX SSG_VOLUME_0,PCR
	STA B,X
	PULS X

SSG_ENVTYPE_END
	RTS

**** SSGGx[v"M"

SSG_ENVLENGTH
	LDD ,X++
	PSHS B,A	: {2
	LDB ,U
	CMPB #$03
	BLO SSG_ENVLENGTH_END

	LDA #$0B
	LDB 1,S
	LBSR WRITE_OPN

	LDA #$0C
	LDB ,S
	LBSR WRITE_OPN

SSG_ENVLENGTH_END
	LEAS 2,S	: 2}
	RTS

**** OPNFݒ"@"

SET_VOICE
	PSHS Y
	LEAY OPN_VOICENUM_0,PCR
	LDB ,U
	CMPB #$03
	BHS SET_VOICE_END

	LDA ,X+
	STA B,Y			: Fԍݒ

	BSR WRITE_VOICE

SET_VOICE_END
	PULS Y
	RTS

**** Ff[^OPNɏ
**** A:VOICE NUMBER 0`  U:CHANNEL
**** use B,Y

WRITE_VOICE
	LEAY FUNCNUM + $7EF,PCR

WRITE_VOICE_NUM1
	LEAY 32,Y
	DECA
	BPL WRITE_VOICE_NUM1

WRITE_VOICE_SET1
	LDA #$30
	ADDA ,U
WRITE_VOICE_LOOP1
	LDB ,Y+
	LBSR WRITE_OPN		: Ff[^
	ADDA #$04
	CMPA #$A0
	BLO WRITE_VOICE_LOOP1
	ADDA #$10
	CMPA #$B4
	BLO WRITE_VOICE_LOOP1

	RTS

**** WX^ݒ"Y"

SET_REGISTER
	LDD ,X++
	CMPA #$07
	BNE SET_REGISTER_NORMAL
SET_REGISTER_SSG_KEYON
	PSHS B,A
	LDA #$09
	LDB ,U
	SUBB #$03
	LBSR LSHIFT
	TFR A,B
	ANDB 1,S
	STB 1,S
	COMA
	ANDA SSG_KEYON,PCR
	ORA 1,S
	STA 1,S
	PULS A,B
	STB SSG_KEYON,PCR	: SSG KEY-ON
	BRA SET_REGISTER_END
SET_REGISTER_NORMAL
	LBSR WRITE_OPN		: f[^
SET_REGISTER_END
	RTS

**** JUMP

PLM_CMD_JUMP
	LDD ,X++
	LEAX D,X
	RTS

**** 

IGNORE_COMMAND
	LEAX 1,X	: ǂݔ΂
	RTS

**** 낢돉

INIT_PARAMS
	BSR INIT_DATA_CURRENT
	LBSR INIT_REMAIN_TIME
	LBSR INIT_OCTAVE
	LBSR INIT_SCORE_NUM
	LBSR INIT_VOLUME
	LBSR INIT_VOICE

	CLR LOOP,PCR
	LDA #$10
	STA TEMPO,PCR
	CLR SSG_ENVELOP,PCR

	LDA #$04
	STA P_KEYBOARD	: L[{[h荞݋֎~

	RTS

**** 낢㏈

TERM_PARAMS
	PSHS B,A
	LDD #$07FF
	BSR WRITE_OPN
	LDD #$2800
	BSR WRITE_OPN
	LDD #$2801
	BSR WRITE_OPN
	LDD #$2802
	BSR WRITE_OPN
	LDA #$44
	STA P_KEYBOARD	: L[{[h荞݋
	PULS A,B,PC

**** OPNWX^
**** A:ADDRAhX B:DATAf[^
WRITE_OPN
	STA P_OPNADDR
	STB P_OPNDATA
	RTS

**** f[^ʒu

INIT_DATA_CURRENT
	LDA #$F8
	STA SSG_KEYON,PCR

	CLRB
	LEAX FUNCNUM + $7FF,PCR	: DATA START
	LEAY DATA_START_0,PCR
INIT_DATA_CURRENT_L1
	PSHS B			: {1
	LDD ,X++
	BEQ INIT_DATA_CURRENT_NODATA
**** CHf[^ւ̃ItZbgvZ
	LEAX -2,X
	TFR X,D
	ADDD ,X++
	BRA INIT_DATA_CURRENT_J2
**** wCHɃf[^Ȃ
INIT_DATA_CURRENT_NODATA
	PSHS B,A		: {2
	LDB 2,S
	CMPB #$03
	BLO INIT_DATA_CURRENT_NODATA_J1
**** SSG̉OFF
	LDA #$09
	SUBB #$03
	LBSR LSHIFT
	ORA SSG_KEYON,PCR
	STA SSG_KEYON,PCR
INIT_DATA_CURRENT_NODATA_J1
	PULS A,B		: 2}
INIT_DATA_CURRENT_J2
	STD ,Y++
	PULS B			: 1}
	INCB
	CMPB #CHANNEL_MAX
	BNE INIT_DATA_CURRENT_L1

	LDB #CHANNEL_MAX
	ASLB
	LEAX DATA_START_0,PCR
	LEAY DATA_CURRENT_0,PCR
	BRA MEMCPY

**** c^C

INIT_REMAIN_TIME
	LDA #$FF
	LDB #CHANNEL_MAX
	ASLB
	LEAX REMAIN_TIME_0,PCR
	BRA MEMSET

**** IN^[u

INIT_OCTAVE
	LDA #$04
	LDB #CHANNEL_MAX
	LEAX OCTAVE_0,PCR
	BRA MEMSET

**** XRAԍ

INIT_SCORE_NUM
	LDA #$00
	LDB #CHANNEL_MAX
	LEAX SCORE_NUM_0,PCR
	BRA MEMSET

**** {[

INIT_VOLUME
	LDA #$00
	LDB #$0C
	LEAX OPN_VOLUME_0,PCR
	BSR MEMSET
	LDA #$08
	LDB #$03
	LEAX SSG_VOLUME_0,PCR
	BRA MEMSET

**** F

INIT_VOICE
	LEAX OPN_VOICENUM_0,PCR
	LDA #$00
	LDB #$03
	BSR MEMSET

	LEAU CHANNEL,PCR
	LDA #$02
	STA ,U
INIT_VOICE_LOOP
	CLRA
	LBSR WRITE_VOICE
	DEC ,U
	BGE INIT_VOICE_LOOP
	CLR ,U
	RTS

**** MEMCPY
****  B:LENGTH X:SRC Y:DST
MEMCPY
	PSHS A
MEMCPY_LOOP
	LDA ,X+
	STA ,Y+
	DECB
	BNE MEMCPY_LOOP
	PULS A,PC

**** MEMSET
****  A:DATA B:LENGTH X:DST
MEMSET
	STA ,X+
	DECB
	BNE MEMSET
	RTS

**** Left shift
**** A:value B:shift count
LSHIFT
	TSTB
	BEQ LSHIFT_END
	LSLA
	DECB
	BRA LSHIFT
LSHIFT_END
	RTS

**** Backup timer (firq) vector

BACKUP_FIRQ_VECTOR
	PSHS U,X,B,A,CC
	ORCC $50
	LDA #$82
	STA P_TIME_MASK		: Stop timer
	LDB #$03
	LDX #P_VECFIRQ
	LEAU VECFIRQ_BACKUP,PCR

J_FIRQ_VECTOR_1
	LDA ,X+
	STA ,U+
	DECB
	BNE J_FIRQ_VECTOR_1
	PULS CC,A,B,X,U,PC

**** Restore timer (firq) vector

RESTORE_FIRQ_VECTOR
	PSHS U,X,B,A,CC
	ORCC $50
	LDA #$02
	STA P_TIME_MASK		: Accept timer
	LDB #$03
	LEAX VECFIRQ_BACKUP,PCR
	LDU #P_VECFIRQ
	BRA J_FIRQ_VECTOR_1

**** Set timer (firq) vector

SET_FIRQ_VECTOR
	PSHS U,X,B,A,CC
	ORCC $50
	LDX #P_VECFIRQ
	LDA #$7E
	STA ,X+
	LEAU FIRQ_SUBROUTINE,PCR
	TFR U,D
	STD ,X
	PULS CC,A,B,X,U,PC

*****
***** ^CgȂǂ̕擾

	ORG $B600
****	SETDP $C0

GET_STRING
	BRA GET_STRING_START

STRING_VEC	FDB $0000
STRING_ARG	FDB $0000
STRING_WORK	FDB $0000

GET_STRING_START
	PSHS U,Y,X,DP,B,A,CC

	LEAX STRING_ARG,PCR
	LEAU GET_STRING+$210,PCR
	TFR U,D
	ADDD #$0100		: `FbN͈
	STD STRING_WORK,PCR

GET_STRING_CHECK
	LDD ,U+
	CMPD #$4154	: 'AT'
	BNE GET_STRING_J1
GET_STRING_IS_AT
	LEAU 31,U
	BRA GET_STRING_CHECK
GET_STRING_J1
	CMPD ,X		: 'DT' or 'EC'
	BNE GET_STRING_J2
	BRA GET_STRING_IS_TITLE
GET_STRING_J2
	CMPU STRING_WORK,PCR
	BLO GET_STRING_CHECK
	BRA GET_STRING_EMPTY
GET_STRING_END
	PULS CC,A,B,DP,X,Y,U
	RTS

GET_STRING_IS_TITLE
	LDX 4,S
	LDY $F024
	CLRB
GET_STRING_IS_TITLE_L
	LEAU 1,U
	LDA ,U
	STA ,Y+
	BEQ GET_STRING_IS_TITLE_1
	INCB
	BRA GET_STRING_IS_TITLE_L
GET_STRING_IS_TITLE_1
	PSHS U
	LDU $F024
	LDX STRING_VEC,PCR
	SWI2
	FCB $41,$38	: MDI128
	PULS U
	BRA GET_STRING_END

GET_STRING_EMPTY
***	LDX 4,S
***	CLR ,X
	BRA GET_STRING_END

